package cn.ibizlab.core.sample.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.sample.domain.IBIZSample0019;
import cn.ibizlab.core.sample.filter.IBIZSample0019SearchContext;
import cn.ibizlab.core.sample.service.IIBIZSample0019Service;

import cn.ibizlab.util.helper.CachedBeanCopier;
import cn.ibizlab.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.sample.mapper.IBIZSample0019Mapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[部门] 服务对象接口实现
 */
@Slf4j
@Service("IBIZSample0019ServiceImpl")
public class IBIZSample0019ServiceImpl extends ServiceImpl<IBIZSample0019Mapper, IBIZSample0019> implements IIBIZSample0019Service {

    @Autowired
    @Lazy
    protected cn.ibizlab.core.sample.service.IIBIZSample0020Service ibizsample0020Service;

    @Autowired
    @Lazy
    protected cn.ibizlab.core.sample.service.logic.IIBIZSample0019UpdateYGNameLogic updateygnameLogic;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(IBIZSample0019 et) {
        if(!this.retBool(this.baseMapper.insert(et))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizsample0019id()), et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<IBIZSample0019> list) {
        this.saveBatch(list, batchSize);
    }

    @Override
    @Transactional
    public boolean update(IBIZSample0019 et) {
        if(!update(et, (Wrapper) et.getUpdateWrapper(true).eq("ibizsample0019id", et.getIbizsample0019id()))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizsample0019id()), et);
        updateygnameLogic.execute(et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<IBIZSample0019> list) {
        updateBatchById(list, batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result = removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public IBIZSample0019 get(String key) {
        IBIZSample0019 et = getById(key);
        if(et == null){
            et = new IBIZSample0019();
            et.setIbizsample0019id(key);
        }
        else {
        }
        return et;
    }

    @Override
    public IBIZSample0019 getDraft(IBIZSample0019 et) {
        return et;
    }

    @Override
    public boolean checkKey(IBIZSample0019 et) {
        return (!ObjectUtils.isEmpty(et.getIbizsample0019id())) && (!Objects.isNull(this.getById(et.getIbizsample0019id())));
    }
    @Override
    @Transactional
    public boolean save(IBIZSample0019 et) {
        if(!saveOrUpdate(et)) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(IBIZSample0019 et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? getProxyService().update(et) : getProxyService().create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<IBIZSample0019> list) {
        List<IBIZSample0019> create = new ArrayList<>();
        List<IBIZSample0019> update = new ArrayList<>();
        for (IBIZSample0019 et : list) {
            if (ObjectUtils.isEmpty(et.getIbizsample0019id()) || ObjectUtils.isEmpty(getById(et.getIbizsample0019id()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<IBIZSample0019> list) {
        List<IBIZSample0019> create = new ArrayList<>();
        List<IBIZSample0019> update = new ArrayList<>();
        for (IBIZSample0019 et : list) {
            if (ObjectUtils.isEmpty(et.getIbizsample0019id()) || ObjectUtils.isEmpty(getById(et.getIbizsample0019id()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
    }



    /**
     * 查询集合 默认
     */
    @Override
    public Page<IBIZSample0019> searchDefault(IBIZSample0019SearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZSample0019> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<IBIZSample0019>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<IBIZSample0019> getIbizsample0019ByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<IBIZSample0019> getIbizsample0019ByEntities(List<IBIZSample0019> entities) {
        List ids =new ArrayList();
        for(IBIZSample0019 entity : entities){
            Serializable id=entity.getIbizsample0019id();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0) {
            return this.listByIds(ids);
        }
        else {
            return entities;
        }
    }





    public IIBIZSample0019Service getProxyService() {
        return cn.ibizlab.util.security.SpringContextHolder.getBean(this.getClass());
    }
}



